#include "LedControl.h"
#define DIN_PIN 4
#define CLK_PIN 2
#define LOAD_PIN 3
#define DIGITS 4
#define POTENTIOMETER_PIN A0

LedControl lc = LedControl(DIN_PIN, CLK_PIN, LOAD_PIN, 1);

void setup() {
  lc.shutdown(0, false);
  lc.setIntensity(0, 15);
  updateDisplay(0, 3);
}

void loop() {
  float volt = analogRead(POTENTIOMETER_PIN) * 5.0 / 1023;
  updateDisplay(volt, 3);
  delay(100);
}

void updateDisplay(float number, int decimals) {
  decimals = constrain(decimals, 0, DIGITS-1);
  int numToShow = number * pow(10, decimals);
  int currentDigit;

  for (int i = 0; i < DIGITS; i++) {
    currentDigit = (int) (numToShow / pow(10, DIGITS-1-i)) % 10;
    lc.setDigit(0, i, currentDigit, DIGITS-1-i == decimals);
  }
}
